use diesel::prelude::*;

#[derive(Queryable, Identifiable, Eq, PartialEq, Debug, Associations, AsChangeset, Clone)]
#[diesel(belongs_to(crate::db::User, foreign_key = owner_id))]
#[diesel(table_name = crate::schema::inode)]
#[diesel(treat_none_as_null = true)]
pub struct Inode {
    pub id: i32,
    pub is_file: bool,
    pub name: String,
    pub parent_id: Option<i32>,
    pub owner_id: i32,
    pub size: Option<i64>,
    pub has_preview: bool
}

#[derive(Insertable, Debug)]
#[diesel(table_name = crate::schema::inode)]
pub struct NewInode {
    pub is_file: bool,
    pub name: String,
    pub parent_id: Option<i32>,
    pub owner_id: i32,
    pub size: Option<i64>,
    pub has_preview: bool
}
